<?
/*
FUNCTION: Script welches von der READ - RegisterVariable der COM-Schnittstelle
          zugewiesen ist

Release: 0.2
ReleaseDate: 24.12.2012

CHANGELOG:
18.04.2009 Gusenbauer R0.1
 + Erste funtionierendes Script

18.04.2009 Gusenbauer R.02
 + Anpassungen an IPS2.7 - PHP5.4
 + Buffer mit $_IPS['VALUE'] anstatt $IPS_VALUE
*/


//** CONFIG ******************************************************************

// hier die InstanzIDs zuweisen
$ComPortID         = 33848 ;
$RegVar_COM3_READ  = 35886  ;
//****************************************************************************

//--------------------------------------------------
//BUFFER FUELLEN --> Daten lesen von COM-Port
$buf = RegVar_GetBuffer($RegVar_COM3_READ);
$buf .= $_IPS['VALUE'];
RegVar_SetBuffer($RegVar_COM3_READ,$buf);
//--------------------------------------------------

   if (strlen($buf)>= 2)
        {
         if (ord($buf[0]) == 21)
             {
             switch (ord($buf[1]))
                    {
                     case 1:
                       echo "ERROR: LOGO! kann kein Telegramm annehmen";
                       break;
                     case 3:
                       echo "ERROR: LOGO! nicht zulssiger Zugriff";
                       break;
                     case 4:
                       echo "ERROR: LOGO! Paritts-, berlauf- oder Telegramfehler";
                       break;
                     case 5:
                       echo "ERROR: LOGO! unbekanntes / unzulaessiges Kommando";
                       break;
                     case 6:
                       echo "ERROR: LOGO! XOR-Summe fehlerhaft";
                       break;
                     case 7:
                       echo "ERROR: LOGO! Simulationsfehler";
                       break;
                     default:
                       echo "ERROR: LOGO! Unbekannter Fehlercode oder UEBERTRAGUNGSFEHLER";
                       break;
                    }

              echo "  --> Fehler im LESEROUTINE\r\n";
             }
        }
//+ + + + + + + + + + + + + + + + + + + + + + + + + + +

//+ + + + + + + + + + + + + + + + + + + + + + + + + + +
$ReadingBytesForLogoTyp = 71;
$ByteLogoTyp = 8;

   if (strlen($buf)>= $ByteLogoTyp+1)
        {
             //Festlegen wieviele Bytes fuer den LOGO-Typ zu lesen sind !!!

             switch (ord($buf[$ByteLogoTyp]))
                    {
                     case 17: //LOGO!-Typ: 0BA4 / 0BA5
                             $ReadingBytesForLogoTyp = 71;
                             break;
                     case 25: //LOGO!-Typ: 0BA6
                             $ReadingBytesForLogoTyp = 81;
                             break;
                     default:
                             $ReadingBytesForLogoTyp = 71;
                             break;
                    }
         }
//+ + + + + + + + + + + + + + + + + + + + + + + + + + +



// # # # # # # # # # # # # # # # # # # # # # # # # # #
// WENN ALLE ZEICHEN EMPFANGEN
// # # # # # # # # # # # # # # # # # # # # # # # # # #
   if (strlen($buf)>= $ReadingBytesForLogoTyp)
        {

             //--------------------------------------------
             // START USERCODE - HIER DIE VERARBEITUNG DURCHFUHREN

             include_once ('./common_function.php');

             $LOGO_Path = "LOGO/ELEMENTE/";

             LOGO_Element("Q",1,$LOGO_Path ."Q1");
             LOGO_Element("I",1,$LOGO_Path ."I1");
             LOGO_Element("AQ",1,$LOGO_Path ."AQ1");

             LOGO_Element("B",1,$LOGO_Path ."/BLOECKE/B1");
             LOGO_Element("B",2,$LOGO_Path ."/BLOECKE/B2");
             LOGO_Element("B",3,$LOGO_Path ."/BLOECKE/B3");
             LOGO_Element("B",4,$LOGO_Path ."/BLOECKE/B4");

             if (LOGO_Element("I",3) == true)
                {
                 echo "I3=1 --> Einbruch erkannt !!!";
                }

             // ENDE USERCODE
             //--------------------------------------------
        }


/*
F U N K T I O N E N  - F U N K T I O N E N - F U N K T I O N E N - F U N K T I O N E N
*/

/****************************************************************************
LOGO_Element,
  extrahiert aus den BUFFER das gewnschte Element

Example:  LOGO_Element("I",4,"LOGO/INPUT/I4");

Parameter: $Typ            --> Bezeichner welche aus dem LOGO-Bezeichner entsprechen
                                Unterstuetze TYPEN: B = Blcke
                                                    I = Eingnge
                                                    F = Funktionstasten
                                                    Q = Ausgnge
                                                    M = Merker
                                                    S = Schieberegister
                                                    C = Cursortasten
                                                    AI = Analogeingang
                                                    AQ = Analogausgang
                                                    AM = Analogmerker
           $Element         --> Elementenummer des Typ (z.B. 1-16)

           $VariableString  --> wenn "" dann nur als Rueckgabewert
                            --> wenn ungleich "", dann wird der Wert auf die
                                Variable "$VariablenString" zugewiesen, existiert
                                die Variable nicht wird diese erzeugt, notigenfalls
                                auch die CategoryHierachie


Info aus dem SIEMENS-Forum:
da bei mir der Puffer auch das ACK enhlt verschiebt sich da ganze +1

Byte Bedeutung
0 Start = 85 (0x55)
1 Kommando = 17 (0x11)
2 Kommando = 17 (0x11)
3-4 Anzahl folgender Bytes
5-6 Prfsumme des Programms
7 Lnge des Bereichs Blcke in Byte
8 Lnge des Bereichs Eingnge bis Analoge Merker in Byte
9 Lnge des Bereichs mit den Aktualwerten der Blcke in Byte

 0BA4, 0BA5:
  10-26   Blcke B1 - B130
  27-29 Eingnge I1 - I24
  30-31 Ausgnge A1 - A16
  32-34 Merker M1 - M24
  35 Schieberegister
  36 Cursortasten
  37-52 Analoge Eingnge AI1 - AI8
  53-56 Analoge Ausgnge AQ1 - AQ2
  57-68 Analoge Merker AM1 - AM6
  69 Stopp = 170 (keine Aktualwerte) (0xAA)

 0BA6:
  10-34 Blcke B1 - B200
  35-37 Eingnge I1 - I24
  38 TD-Funktionstasten
  39-40 Ausgnge A1 - A16
  41-44 Merker M1 - M27
  45 Schieberegister
  46 Cursortasten
  47-62 Analoge Eingnge AI1 - AI8
  63-66 Analoge Ausgnge AQ1 - AQ2
  67-78 Analoge Merker AM1 - AM6
  79 Stopp = 170 (keine Aktualwerte)  (0xAA)


ReleaseNotes:
18.04.2009 Gusenbauer
 + Function erstellt und geprft (jedoch alle ANALOGWERTE nicht getestet !!!)
24.12.2012 Gusenbauer
 + Anpassungen fuer IPS2.7-PHP5.4
   $ElementValue = (ord($buf[$ByteOffset]))
   ==> Waring: String offset cast occurred
   ord($buf[8])
   ==> Waring: Uninitialized string offset: 8
*****************************************************************************/

function LOGO_Element($Typ,$Element,$VariableString="")
 {
  global $buf;
  $ByteLogoTyp = 8;

  switch (ord($buf[$ByteLogoTyp]))
        {
         case 17: //LOGO!-Typ: 0BA4 / 0BA5
                  $LogoTyp = "0BA5";
                  break;
         case 25: //LOGO!-Typ: 0BA6
                  $LogoTyp = "0BA6";
                  break;
         default:
                  $LogoTyp = "0BA3";
                  break;
        }


  $MinElement = 0;
  $MaxElement = 0;
  $ByteOffset = 0;
  $VariablenTyp = 0;
  $BytesProElement = 0;

  switch (strtoupper($Typ))
     {
      case "B": //BLOECKE
                $MinElement = 1;
                $MaxElement = 130;
                $VariablenTyp = 0; //Boolean
                if ($LogoTyp = "0BA5")
                   {
                    $MaxElement = 130;
                    $ByteOffset = 11;
                   }
                else
                   {
                    $MaxElement = 200;
                    $ByteOffset = 11;
                   }
                break;

      case "I": //EINGAENGE
                $MinElement = 1;
                $MaxElement = 24;
                $VariablenTyp = 0; //Boolean
                if ($LogoTyp = "0BA5")
                   {
                    $ByteOffset = 28;
                   }
                else
                   {
                    $ByteOffset = 36;
                   }
                break;

      case "F": //FUNKTIONSTASTEN nur an OBA6
                $MinElement = 1;
                $MaxElement = 4;
                $VariablenTyp = 0; //Boolean
                if ($LogoTyp = "0BA5")
                   {
                    $MinElement = 0;
                    $MaxElement = 0;
                    $ByteOffset = 0;
                   }
                else
                   {
                    $ByteOffset = 39;
                   }
                break;

      case "Q": //AUSGAENGE
                $MinElement = 1;
                $MaxElement = 16;
                $VariablenTyp = 0; //Boolean
                if ($LogoTyp = "0BA5")
                   {
                    $ByteOffset = 31;
                   }
                else
                   {
                    $ByteOffset = 40;
                   }
                break;

      case "M": //MERKER
                $MinElement = 1;
                $MaxElement = 27;
                $VariablenTyp = 0; //Boolean
                if ($LogoTyp = "0BA5")
                   {
                    $ByteOffset = 33;
                   }
                else
                   {
                    $ByteOffset = 42;
                   }
                break;

      case "S": //SCHIEBEREGISTER
                $MinElement = 1;
                $MaxElement = 8;
                $VariablenTyp = 0; //Boolean
                if ($LogoTyp = "0BA5")
                   {
                    $ByteOffset = 36;
                   }
                else
                   {
                    $ByteOffset = 46;
                   }
                break;

      case "C": //CURSORTASTEN
                $MinElement = 1;
                $MaxElement = 4;
                $VariablenTyp = 0; //Boolean
                if ($LogoTyp = "0BA5")
                   {
                    $ByteOffset = 37;
                   }
                else
                   {
                    $ByteOffset = 47;
                   }
                break;

      case "AI": //ANALOGEINGANG
                 $MinElement = 1;
                 $MaxElement = 8;
                 $VariablenTyp = 1;    //Integer
                 $BytesProElement = 2;
                 if ($LogoTyp = "0BA5")
                    {
                     $ByteOffset = 38;
                    }
                 else
                    {
                     $ByteOffset = 48;
                    }
                 break;

      case "AQ": //ANALOGAUSGANG
                 $MinElement = 1;
                 $MaxElement = 2;
                 $VariablenTyp = 1;    //Integer
                 $BytesProElement = 2;
                 if ($LogoTyp = "0BA5")
                    {
                     $ByteOffset = 54;
                    }
                 else
                    {
                     $ByteOffset = 63;
                    }
                break;

      case "AM": //ANALOGMERKER
                 $MinElement = 1;
                 $MaxElement = 6;
                 $VariablenTyp = 1;    //Integer
                 $BytesProElement = 2;
                 if ($LogoTyp = "0BA5")
                    {
                     $ByteOffset = 58;
                    }
                 else
                    {
                     $ByteOffset = 68;
                    }
                 break;

      default:
             echo "ERROR: Typ unbekannt --> " . strtoupper($Typ) ."\r\n";
             break;
      }


  if (($Element < $MinElement) || ($Element > $MaxElement))
      {
       echo "ERROR: Elementennummer unzulaessig --> " . strtoupper($Typ) . $Element . " (nur " . $MinElement . " - " . $MaxElement . " erlaubt) \r\n";
      }
  else
      {
        $VariableString = str_replace(chr(92),"/",$VariableString);

        //Check ob sich die Variable in einer Objekthierachie befinden soll
        if (strrpos($VariableString, "/") !== false)
            {
              $PathString = substr($VariableString,0,strrpos($VariableString, "/")+1);

              //Check ob eine Objekthierachie exitiert (Egal ob Objekt/Script/..)
              $ret = CheckObjektHierachie($PathString);

             if ($ret <= 0)
                {
                 //existiert die Objekthiearachie nicht wird eine Categoryhierachie erzeugt
                 CheckCreateCategory($PathString);
                }
            }

         if($VariablenTyp == 0) //Boolean
            {
             $ByteOffset += floor(($Element-1)/8);
             $BitOffset  = fmod(($Element-1),8);
             //echo "BYTEOffeset = " . $ByteOffset . " / BitOffset = " . $BitOffset;
             $ElementValue = (ord($buf[(int)$ByteOffset]) & pow(2, $BitOffset)) >> $BitOffset;

             if($VariableString != "")
               {
                //Check ob Variable existiert bzw. erzeugen (BOOLEAN)
                $VarID = CheckCreateVariable($VariableString,0);

                //Wert auf ElementenVariable zuweisen
                SetValueBoolean($VarID,ConvertToBoolean($ElementValue));
               }
             return(ConvertToBoolean($ElementValue));
            }
       else
            {
             $ByteOffset += ($Element-1)*$BytesProElement;
             //echo "BYTEOffeset = " . $ByteOffset ."\r\n";

             $ElementValue = 0;
             for ($i=$BytesProElement-1;$i>=0;$i--)
                 {
                  $ElementValue = ($ElementValue << 8);
                  $ElementValue = $ElementValue + ord($buf[(int)($ByteOffset+$i)]);

                  //Wert ist negativ
                  if ($ElementValue > 32767)
                      {
                  $ElementValue = $ElementValue - 65536;
                      }
                  }

             if($VariableString != "")
               {
                //Check ob Variable existiert bzw. erzeugen (INTEGER)
                $VarID = CheckCreateVariable($VariableString,1);

                //Wert auf ElementenVariable zuweisen
                SetValueInteger($VarID,$ElementValue);
              }

            //echo "elemetenWert = " . $ElementValue ."\r\n";
            return($ElementValue);
            }
     }

 }
//****************************************************************************

?>